import { Observable } from 'rxjs';
import { InjectionToken } from '@angular/core';
export declare const HG_ASYNC_RENDER_RESOLVER: InjectionToken<string>;
export declare enum ResolverConfig {
    Default = 0,
    AutoResolveOnce = 1,
    AutoResolve = 2
}
interface IActionsTarget<D> {
    loadAction: (deps: D) => void;
    cancelAction: () => void;
    success$: Observable<any>;
    failure$: Observable<any>;
}
declare type FunctionObservableTarget<T, D> = (deps: D) => Observable<T>;
export declare class AsyncRenderResolver<T, D = any> {
    private targetFn;
    private dependencies;
    protected config: ResolverConfig;
    private _isAlive$;
    private _shouldSkip;
    private _autoResolveOnceCompleted;
    private _dependencySubscription;
    private _resolveRequested;
    private _state;
    private _data$;
    private _dataObservable$;
    private _functionObservableSubscription;
    readonly isLoading: boolean;
    readonly hasErrored: boolean;
    error: Error;
    readonly data$: Observable<T>;
    shouldSkip: boolean;
    private readonly isFunctionObservableTarget;
    constructor(targetFn: IActionsTarget<T> | FunctionObservableTarget<T, D>, dependencies?: () => (Observable<any> | any[]) | Observable<any> | Observable<any>[]);
    resolve(auto?: boolean): void;
    destroy(): void;
}
export {};
